package com.cloveretl.customctl;

import org.jetel.ctl.Stack;
import org.jetel.ctl.extensions.TLFunctionAnnotation;
import org.jetel.ctl.extensions.TLFunctionCallContext;
import org.jetel.ctl.extensions.TLFunctionLibrary;
import org.jetel.ctl.extensions.TLFunctionPrototype;
import de.svenjacobs.loremipsum.LoremIpsum;

public class LoremIpsumCTLLibrary extends TLFunctionLibrary {
	
	LoremIpsum loremIpsum = new LoremIpsum();

	@Override
	public TLFunctionPrototype getExecutable(String functionName)
			throws IllegalArgumentException {
		TLFunctionPrototype ret = 
				"getWords".equals(functionName) ? new GetWordsFunction() : null;		
		return ret;
	}

	@Override
	public String getName() {
		return "LoremIpsumCTLLibrary";
	}
	
	@TLFunctionAnnotation("Generates Lorem Ipsum text")
	public String getWords(TLFunctionCallContext context) {
		return this.loremIpsum.getWords();
	}

	@TLFunctionAnnotation("Generates Lorem Ipsum text")
	public String getWords(TLFunctionCallContext context, Integer count) {
		if(count==null) {
			return this.getWords(context);
		}
		return this.loremIpsum.getWords(count);
	}

	class GetWordsFunction implements TLFunctionPrototype {
		@Override
		public void execute(Stack stack, TLFunctionCallContext context) {
			if (context.getParams().length > 0) {
				stack.push(getWords(context, stack.popInt()));			
			}else{
				stack.push(getWords(context));			
			}
		}
		@Override
		public void init(TLFunctionCallContext context) { }	
	}
}
